@echo off
REM //==============================================================================
REM /**
REM * @file    conv_swf10.bat
REM * @brief   swf6～swf8のファイルを、swf10に変換するコンバーター
REM * @author  com04
REM * @date    2012-08-23
REM * @version 1.0.2
REM */
REM //==============================================================================

setlocal enabledelayedexpansion

rem swfmill.exeがあるパス。ディレクトリの区切りは\\で。
set SWFMILL_PATH="D:\\workspace\\tools\\swfmill-0.3.2-win32\\swfmill.exe"



set CONVERT_EXEXC_PATH=%~dp0\src\convert_swf10_xml_stop.exe

rem 引数のファイルを繰り返す
for %%i in (%*) do (
  set SWF_FILE=%%~i
  set SWF_TMP_FILE=%%~i.tmp
  set XML_FILE=%%~dpni.xml
  set XML_TMP_FILE=%%~dpni.tmp.xml
  set BACKUP_FILE=%%~i.back
  
  @echo on
  echo Convert File: !SWF_FILE!
  @echo off
  
  rem SWFファイルからXMLを作成
  %SWFMILL_PATH% swf2xml "!SWF_FILE!" "!XML_FILE!"
  if errorlevel 1 (
    @echo on
    echo [ERROR] Can't Convert swf to xml File.
    @echo off
    
    goto ERROR
  )

  rem コンバートするのに必要な文字列を置き換える
  type nul>"!XML_TMP_FILE!"
  
  rem XMLデータの変換
  call :ConvertXML
  
  rem タグ変換したのなら（エラーが無ければ）
  if !errorlevel! == 0 (
    rem 書き換えたXMLからSWFを生成する
    %SWFMILL_PATH% xml2swf "!XML_TMP_FILE!" "!SWF_TMP_FILE!"
    if !errorlevel! == 1 (
      @echo on
      echo [ERROR] Can't Convert xml to swf File.
      @echo off
      
      goto ERROR
    )
    rem 念のためバックアップ
    copy "!SWF_FILE!" "!BACKUP_FILE!"
    copy "!SWF_TMP_FILE!" "!SWF_FILE!"
  )


  rem 中間ファイル削除
  if exist "!SWF_TMP_FILE!" del "!SWF_TMP_FILE!"
  if exist "!XML_TMP_FILE!" del "!XML_TMP_FILE!"
  if exist "!XML_FILE!" del "!XML_FILE!"
)


goto END

:ERROR
@echo on
echo Error Stoped!!!!

:END

endlocal

@echo on
pause

exit /b


REM //---------------------------------------------------------
REM /**
REM  * XMLをSWF10の形式に変換する
REM  *
REM  * @return 0 : 変換する必要がある 
REM  * @return 1 : 変換しなくていい(SWF10のファイル）
REM  */
REM //---------------------------------------------------------
:ConvertXML
echo %CONVERT_EXEXC_PATH%
call %CONVERT_EXEXC_PATH% "!XML_FILE!" "!XML_TMP_FILE!"

exit /b !errorlevel!



