//==============================================================================
/**
 * @file    static_assert.hpp
 * @brief   StaticなAssert
 * @author  H.I.
 * @date    2011-05-29
 * @version $Id: static_assert.hpp 37 2011-06-01 17:23:31Z blue $
 */
//==============================================================================

#ifndef HIL_STATIC_ASSERT_HPP
#define HIL_STATIC_ASSERT_HPP


//==============================================================================
//        インクルード
//==============================================================================
#include <iostream>
#include "common.hpp"


HIL_BEGIN_NAMESPACE;

namespace common {
//==============================================================================
//        定数宣言
//==============================================================================


//==============================================================================
/**
 * StaticなAssertionを実現する為のトリック。trueのtemplateだけ定義する
*/
//==============================================================================
template <bool>
struct clStaticAssert;
template<>
struct clStaticAssert<true>{};
template<int test>
struct clStaticAssertTest{};
}
HIL_END_NAMESPACE;

/// StaticなAssert
#define STATIC_ASSERT(n) \
  typedef hil::common::clStaticAssertTest< \
      sizeof(hil::common::clStaticAssert<static_cast<bool>(n)>)> \
      __FILE__##__LINE__
  

  
#endif

